Index: liveMedia/include/MPEG4LATMAudioRTPSource.hh
===================================================================
--- liveMedia/include/MPEG4LATMAudioRTPSource.hh	(revision 14473)
+++ liveMedia/include/MPEG4LATMAudioRTPSource.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _MPEG4_LATM_AUDIO_RTP_SOURCE_HH
 #define _MPEG4_LATM_AUDIO_RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #include "MultiFramedRTPSource.hh"
 #endif
@@ -92,7 +98,7 @@
     // (or NULL) if the parsing failed, without bothering with the other
     // result parameters.
 
-unsigned char* parseGeneralConfigStr(char const* configStr,
+LIVEMEDIALIB_API unsigned char* parseGeneralConfigStr(char const* configStr,
 				     // result parameter:
 				     unsigned& configSize);
     // A routine that parses an arbitrary config string, returning
Index: liveMedia/include/MPEG4VideoFileServerMediaSubsession.hh
===================================================================
--- liveMedia/include/MPEG4VideoFileServerMediaSubsession.hh	(revision 14473)
+++ liveMedia/include/MPEG4VideoFileServerMediaSubsession.hh	(revision 14474)
@@ -22,11 +22,17 @@
 #ifndef _MPEG4_VIDEO_FILE_SERVER_MEDIA_SUBSESSION_HH
 #define _MPEG4_VIDEO_FILE_SERVER_MEDIA_SUBSESSION_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FILE_SERVER_MEDIA_SUBSESSION_HH
 #include "FileServerMediaSubsession.hh"
 #endif
 
-class MPEG4VideoFileServerMediaSubsession: public FileServerMediaSubsession{
+class LIVEMEDIALIB_API MPEG4VideoFileServerMediaSubsession: public FileServerMediaSubsession{
 public:
   static MPEG4VideoFileServerMediaSubsession*
   createNew(UsageEnvironment& env, char const* fileName, Boolean reuseFirstSource);
Index: liveMedia/include/MPEG4VideoStreamDiscreteFramer.hh
===================================================================
--- liveMedia/include/MPEG4VideoStreamDiscreteFramer.hh	(revision 14473)
+++ liveMedia/include/MPEG4VideoStreamDiscreteFramer.hh	(revision 14474)
@@ -24,11 +24,17 @@
 #ifndef _MPEG4_VIDEO_STREAM_DISCRETE_FRAMER_HH
 #define _MPEG4_VIDEO_STREAM_DISCRETE_FRAMER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MPEG4_VIDEO_STREAM_FRAMER_HH
 #include "MPEG4VideoStreamFramer.hh"
 #endif
 
-class MPEG4VideoStreamDiscreteFramer: public MPEG4VideoStreamFramer {
+class LIVEMEDIALIB_API MPEG4VideoStreamDiscreteFramer: public MPEG4VideoStreamFramer {
 public:
   static MPEG4VideoStreamDiscreteFramer*
   createNew(UsageEnvironment& env, FramedSource* inputSource, Boolean leavePresentationTimesUnmodified = False);
Index: liveMedia/include/MPEG4VideoStreamFramer.hh
===================================================================
--- liveMedia/include/MPEG4VideoStreamFramer.hh	(revision 14473)
+++ liveMedia/include/MPEG4VideoStreamFramer.hh	(revision 14474)
@@ -26,11 +26,17 @@
 #ifndef _MPEG4_VIDEO_STREAM_FRAMER_HH
 #define _MPEG4_VIDEO_STREAM_FRAMER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MPEG_VIDEO_STREAM_FRAMER_HH
 #include "MPEGVideoStreamFramer.hh"
 #endif
 
-class MPEG4VideoStreamFramer: public MPEGVideoStreamFramer {
+class LIVEMEDIALIB_API MPEG4VideoStreamFramer: public MPEGVideoStreamFramer {
 public:
   static MPEG4VideoStreamFramer*
   createNew(UsageEnvironment& env, FramedSource* inputSource);
Index: liveMedia/include/MPEGVideoStreamFramer.hh
===================================================================
--- liveMedia/include/MPEGVideoStreamFramer.hh	(revision 14473)
+++ liveMedia/include/MPEGVideoStreamFramer.hh	(revision 14474)
@@ -22,11 +22,17 @@
 #ifndef _MPEG_VIDEO_STREAM_FRAMER_HH
 #define _MPEG_VIDEO_STREAM_FRAMER_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FRAMED_FILTER_HH
 #include "FramedFilter.hh"
 #endif
 
-class TimeCode {
+class LIVEMEDIALIB_API TimeCode {
 public:
   TimeCode();
   virtual ~TimeCode();
@@ -35,7 +41,7 @@
   unsigned days, hours, minutes, seconds, pictures;
 };
 
-class MPEGVideoStreamFramer: public FramedFilter {
+class LIVEMEDIALIB_API MPEGVideoStreamFramer: public FramedFilter {
 public:
   Boolean& pictureEndMarker() { return fPictureEndMarker; }
       // a hack for implementing the RTP 'M' bit
Index: liveMedia/include/Media.hh
===================================================================
--- liveMedia/include/Media.hh	(revision 14473)
+++ liveMedia/include/Media.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _MEDIA_HH
 #define _MEDIA_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _LIVEMEDIA_VERSION_HH
 #include "liveMedia_version.hh"
 #endif
@@ -47,7 +53,7 @@
 
 #define mediumNameMaxLen 30
 
-class Medium {
+class LIVEMEDIALIB_API Medium {
 public:
   static Boolean lookupByName(UsageEnvironment& env,
 			      char const* mediumName,
Index: liveMedia/include/MediaSession.hh
===================================================================
--- liveMedia/include/MediaSession.hh	(revision 14473)
+++ liveMedia/include/MediaSession.hh	(revision 14474)
@@ -48,6 +48,12 @@
 #ifndef _MEDIA_SESSION_HH
 #define _MEDIA_SESSION_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _RTCP_HH
 #include "RTCP.hh"
 #endif
@@ -57,7 +63,7 @@
 
 class MediaSubsession; // forward
 
-class MediaSession: public Medium {
+class LIVEMEDIALIB_API MediaSession: public Medium {
 public:
   static MediaSession* createNew(UsageEnvironment& env,
 				 char const* sdpDescription);
@@ -141,7 +147,7 @@
 };
 
 
-class MediaSubsessionIterator {
+class LIVEMEDIALIB_API MediaSubsessionIterator {
 public:
   MediaSubsessionIterator(MediaSession const& session);
   virtual ~MediaSubsessionIterator();
@@ -155,7 +161,7 @@
 };
 
 
-class MediaSubsession {
+class LIVEMEDIALIB_API MediaSubsession {
 public:
   MediaSession& parentSession() { return fParent; }
   MediaSession const& parentSession() const { return fParent; }
Index: liveMedia/include/MediaSink.hh
===================================================================
--- liveMedia/include/MediaSink.hh	(revision 14473)
+++ liveMedia/include/MediaSink.hh	(revision 14474)
@@ -20,12 +20,18 @@
 
 #ifndef _MEDIA_SINK_HH
 #define _MEDIA_SINK_HH
+
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
 
 #ifndef _FRAMED_SOURCE_HH
 #include "FramedSource.hh"
 #endif
 
-class MediaSink: public Medium {
+class LIVEMEDIALIB_API MediaSink: public Medium {
 public:
   static Boolean lookupByName(UsageEnvironment& env, char const* sinkName,
 			      MediaSink*& resultSink);
@@ -68,7 +74,7 @@
 };
 
 // A data structure that a sink may use for an output packet:
-class OutPacketBuffer {
+class LIVEMEDIALIB_API OutPacketBuffer {
 public:
   OutPacketBuffer(unsigned preferredPacketSize, unsigned maxPacketSize,
 		  unsigned maxBufferSize = 0);
Index: liveMedia/include/MediaSource.hh
===================================================================
--- liveMedia/include/MediaSource.hh	(revision 14473)
+++ liveMedia/include/MediaSource.hh	(revision 14474)
@@ -21,11 +21,17 @@
 #ifndef _MEDIA_SOURCE_HH
 #define _MEDIA_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MEDIA_HH
 #include "Media.hh"
 #endif
 
-class MediaSource: public Medium {
+class LIVEMEDIALIB_API MediaSource: public Medium {
 public:
   static Boolean lookupByName(UsageEnvironment& env, char const* sourceName,
 			      MediaSource*& resultSource);
Index: liveMedia/include/MetaDataRTPSink.hh
===================================================================
--- liveMedia/include/MetaDataRTPSink.hh	(nonexistent)
+++ liveMedia/include/MetaDataRTPSink.hh	(revision 14474)
@@ -0,0 +1,88 @@
+/**********
+This library is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the
+Free Software Foundation; either version 2.1 of the License, or (at your
+option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)
+
+This library is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
+more details.
+
+You should have received a copy of the GNU Lesser General Public License
+along with this library; if not, write to the Free Software Foundation, Inc.,
+51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
+**********/
+
+////////////////////////////////////////////////////////////////////
+// Copyright 2011 intuVision, inc.
+// intuVision open source - all rights reserved.
+//
+// FILENAME : MetaDataRTPSink.hh
+// AUTHORS  : Ashutosh Morde
+//            intuVision, Inc.
+//            10 Tower Park, Suite 200
+//            Woburn, MA  01801
+//            Email: ashu@intuvisiontech.com
+// DATE     : March 11, 2011
+// DERIVED  : SimpleRTPSink.hh
+////////////////////////////////////////////////////////////////////
+
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
+#ifndef _METADATA_RTP_SINK_HH
+#define _METADATA_RTP_SINK_HH
+
+#ifndef _MULTI_FRAMED_RTP_SINK_HH
+#include "MultiFramedRTPSink.hh"
+#endif
+
+class LIVEMEDIALIB_API MetaDataRTPSink: public MultiFramedRTPSink {
+public:
+  static MetaDataRTPSink*
+  createNew(UsageEnvironment& env, Groupsock* RTPgs,
+	    unsigned char rtpPayloadFormat,
+	    unsigned rtpTimestampFrequency,
+	    char const* sdpMediaTypeString,
+	    char const* rtpPayloadFormatName,
+	    unsigned numChannels = 1,
+	    Boolean allowMultipleFramesPerPacket = True,
+	    Boolean doNormalMBitRule = True);
+  // "doNormalMBitRule" means: If the medium is video, set the RTP "M"
+  // bit on each outgoing packet iff it contains the last (or only)
+  // fragment of a frame.  (Otherwise, leave the "M" bit unset.)
+protected:
+  MetaDataRTPSink(UsageEnvironment& env, Groupsock* RTPgs,
+		unsigned char rtpPayloadFormat,
+		unsigned rtpTimestampFrequency,
+		char const* sdpMediaTypeString,
+		char const* rtpPayloadFormatName,
+		unsigned numChannels,
+		Boolean allowMultipleFramesPerPacket,
+		Boolean doNormalMBitRule);
+	// called only by createNew()
+
+  virtual ~MetaDataRTPSink();
+
+protected: // redefined virtual functions
+  virtual void doSpecialFrameHandling(unsigned fragmentationOffset,
+                                      unsigned char* frameStart,
+                                      unsigned numBytesInFrame,
+                                      struct timeval frameTimestamp,
+                                      unsigned numRemainingBytes);
+  virtual
+  Boolean frameCanAppearAfterPacketStart(unsigned char const* frameStart,
+					 unsigned numBytesInFrame) const;
+  virtual char const* sdpMediaType() const;
+
+private:
+  char const* fSDPMediaTypeString;
+  Boolean fAllowMultipleFramesPerPacket;
+  Boolean fSetMBitOnLastFrames;
+};
+
+#endif
Index: liveMedia/include/MultiFramedRTPSink.hh
===================================================================
--- liveMedia/include/MultiFramedRTPSink.hh	(revision 14473)
+++ liveMedia/include/MultiFramedRTPSink.hh	(revision 14474)
@@ -22,11 +22,17 @@
 #ifndef _MULTI_FRAMED_RTP_SINK_HH
 #define _MULTI_FRAMED_RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _RTP_SINK_HH
 #include "RTPSink.hh"
 #endif
 
-class MultiFramedRTPSink: public RTPSink {
+class LIVEMEDIALIB_API MultiFramedRTPSink: public RTPSink {
 public:
   void setPacketSizes(unsigned preferredPacketSize, unsigned maxPacketSize);
 
@@ -115,9 +121,11 @@
 
   static void ourHandleClosure(void* clientData);
 
-private:
+protected:
+  // IHP: Need access to this for subclasses
   OutPacketBuffer* fOutBuf;
 
+private:
   Boolean fNoFramesLeft;
   unsigned fNumFramesUsedSoFar;
   unsigned fCurFragmentationOffset;
Index: liveMedia/include/MultiFramedRTPSource.hh
===================================================================
--- liveMedia/include/MultiFramedRTPSource.hh	(revision 14473)
+++ liveMedia/include/MultiFramedRTPSource.hh	(revision 14474)
@@ -22,6 +22,12 @@
 #ifndef _MULTI_FRAMED_RTP_SOURCE_HH
 #define _MULTI_FRAMED_RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _RTP_SOURCE_HH
 #include "RTPSource.hh"
 #endif
@@ -29,7 +35,7 @@
 class BufferedPacket; // forward
 class BufferedPacketFactory; // forward
 
-class MultiFramedRTPSource: public RTPSource {
+class LIVEMEDIALIB_API MultiFramedRTPSource: public RTPSource {
 protected:
   MultiFramedRTPSource(UsageEnvironment& env, Groupsock* RTPgs,
 		       unsigned char rtpPayloadFormat,
@@ -55,6 +61,16 @@
   // redefined virtual functions:
   virtual void doStopGettingFrames();
 
+  // IHP: pre-process a data packet
+  virtual void doSpecialPreprocessing(BufferedPacket* packet, unsigned rtpHdr) {}
+
+  // IHP: post-process a data frame
+  virtual void doSpecialPostprocessing( Boolean isEmpty ) {}
+
+  // IHP: Moving these up so we can access them in post-processing
+  unsigned char* fSavedTo;
+  unsigned fSavedMaxSize;
+
 private:
   // redefined virtual functions:
   virtual void doGetNextFrame();
@@ -71,8 +87,6 @@
   BufferedPacket* fPacketReadInProgress;
   Boolean fNeedDelivery;
   Boolean fPacketLossInFragmentedFrame;
-  unsigned char* fSavedTo;
-  unsigned fSavedMaxSize;
 
   // A buffer to (optionally) hold incoming pkts that have been reorderered
   class ReorderingPacketBuffer* fReorderingBuffer;
Index: liveMedia/include/OnDemandServerMediaSubsession.hh
===================================================================
--- liveMedia/include/OnDemandServerMediaSubsession.hh	(revision 14473)
+++ liveMedia/include/OnDemandServerMediaSubsession.hh	(revision 14474)
@@ -22,6 +22,12 @@
 #ifndef _ON_DEMAND_SERVER_MEDIA_SUBSESSION_HH
 #define _ON_DEMAND_SERVER_MEDIA_SUBSESSION_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _SERVER_MEDIA_SESSION_HH
 #include "ServerMediaSession.hh"
 #endif
@@ -35,7 +41,7 @@
 #include "RTCP.hh"
 #endif
 
-class OnDemandServerMediaSubsession: public ServerMediaSubsession {
+class LIVEMEDIALIB_API OnDemandServerMediaSubsession: public ServerMediaSubsession {
 protected: // we're a virtual base class
   OnDemandServerMediaSubsession(UsageEnvironment& env, Boolean reuseFirstSource,
 				portNumBits initialPortNum = 6970,
@@ -92,6 +98,9 @@
   virtual void setStreamSourceDuration(FramedSource* inputSource, double streamDuration, u_int64_t& numBytes);
   virtual void closeStreamSource(FramedSource* inputSource);
 
+  // IHP: adding more info to 'a=control'
+  virtual char const* getControlSPDLine( );
+
 protected: // new virtual functions, defined by all subclasses
   virtual FramedSource* createNewStreamSource(unsigned clientSessionId,
 					      unsigned& estBitrate) = 0;
@@ -134,6 +143,9 @@
   char* fSDPLines;
   HashTable* fDestinationsHashTable; // indexed by client session id
 
+  // IHP: adding more info to 'a=control'
+  const char* fControlLine;
+
 private:
   Boolean fReuseFirstSource;
   portNumBits fInitialPortNum;
Index: liveMedia/include/OutputFile.hh
===================================================================
--- liveMedia/include/OutputFile.hh	(revision 14473)
+++ liveMedia/include/OutputFile.hh	(revision 14474)
@@ -20,12 +20,18 @@
 
 #ifndef _OUTPUT_FILE_HH
 #define _OUTPUT_FILE_HH
+
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
 
 #include <UsageEnvironment.hh>
 #include <stdio.h>
 
-FILE* OpenOutputFile(UsageEnvironment& env, char const* fileName);
+LIVEMEDIALIB_API FILE* OpenOutputFile(UsageEnvironment& env, char const* fileName);
 
-void CloseOutputFile(FILE* fid);
+LIVEMEDIALIB_API void CloseOutputFile(FILE* fid);
 
 #endif
Index: liveMedia/include/RTCP.hh
===================================================================
--- liveMedia/include/RTCP.hh	(revision 14473)
+++ liveMedia/include/RTCP.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _RTCP_HH
 #define _RTCP_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _RTP_SINK_HH
 #include "RTPSink.hh"
 #endif
@@ -28,7 +34,7 @@
 #include "RTPSource.hh"
 #endif
 
-class SDESItem {
+class LIVEMEDIALIB_API SDESItem {
 public:
   SDESItem(unsigned char tag, unsigned char const* value);
 
@@ -45,7 +51,7 @@
 
 class RTCPMemberDatabase; // forward
 
-class RTCPInstance: public Medium {
+class LIVEMEDIALIB_API RTCPInstance: public Medium {
 public:
   static RTCPInstance* createNew(UsageEnvironment& env, Groupsock* RTCPgs,
 				 unsigned totSessionBW, /* in kbps */
Index: liveMedia/include/RTPInterface.hh
===================================================================
--- liveMedia/include/RTPInterface.hh	(revision 14473)
+++ liveMedia/include/RTPInterface.hh	(revision 14474)
@@ -23,6 +23,12 @@
 #ifndef _RTP_INTERFACE_HH
 #define _RTP_INTERFACE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MEDIA_HH
 #include <Media.hh>
 #endif
@@ -52,7 +58,7 @@
   unsigned char fStreamChannelId;
 };
 
-class RTPInterface {
+class LIVEMEDIALIB_API RTPInterface {
 public:
   RTPInterface(Medium* owner, Groupsock* gs);
   virtual ~RTPInterface();
Index: liveMedia/include/RTPSink.hh
===================================================================
--- liveMedia/include/RTPSink.hh	(revision 14473)
+++ liveMedia/include/RTPSink.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _RTP_SINK_HH
 #define _RTP_SINK_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MEDIA_SINK_HH
 #include "MediaSink.hh"
 #endif
@@ -30,7 +36,7 @@
 
 class RTPTransmissionStatsDB; // forward
 
-class RTPSink: public MediaSink {
+class LIVEMEDIALIB_API RTPSink: public MediaSink {
 public:
   static Boolean lookupByName(UsageEnvironment& env, char const* sinkName,
 			      RTPSink*& resultSink);
@@ -133,7 +139,7 @@
 
 class RTPTransmissionStats; // forward
 
-class RTPTransmissionStatsDB {
+class LIVEMEDIALIB_API RTPTransmissionStatsDB {
 public:
   unsigned numReceivers() const { return fNumReceivers; }
 
@@ -174,7 +180,7 @@
   HashTable* fTable;
 };
 
-class RTPTransmissionStats {
+class LIVEMEDIALIB_API RTPTransmissionStats {
 public:
   u_int32_t SSRC() const {return fSSRC;}
   struct sockaddr_in const& lastFromAddress() const {return fLastFromAddress;}
Index: liveMedia/include/RTPSource.hh
===================================================================
--- liveMedia/include/RTPSource.hh	(revision 14473)
+++ liveMedia/include/RTPSource.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _RTP_SOURCE_HH
 #define _RTP_SOURCE_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _FRAMED_SOURCE_HH
 #include "FramedSource.hh"
 #endif
@@ -30,7 +36,7 @@
 
 class RTPReceptionStatsDB; // forward
 
-class RTPSource: public FramedSource {
+class LIVEMEDIALIB_API RTPSource: public FramedSource {
 public:
   static Boolean lookupByName(UsageEnvironment& env, char const* sourceName,
 			      RTPSource*& resultSource);
Index: liveMedia/include/RTSPClient.hh
===================================================================
--- liveMedia/include/RTSPClient.hh	(revision 14473)
+++ liveMedia/include/RTSPClient.hh	(revision 14474)
@@ -21,6 +21,12 @@
 #ifndef _RTSP_CLIENT_HH
 #define _RTSP_CLIENT_HH
 
+#ifdef LIVEMEDIALIB_EXPORTS
+#define LIVEMEDIALIB_API __declspec(dllexport)
+#else
+#define LIVEMEDIALIB_API __declspec(dllimport)
+#endif
+
 #ifndef _MEDIA_SESSION_HH
 #include "MediaSession.hh"
 #endif
@@ -36,7 +42,7 @@
 #endif
 #endif
 
-class RTSPClient: public Medium {
+class LIVEMEDIALIB_API RTSPClient: public Medium {
 public:
   static RTSPClient* createNew(UsageEnvironment& env, char const* rtspURL,
 			       int verbosityLevel = 0,
@@ -179,6 +185,9 @@
   void setUserAgentString(char const* userAgentName);
       // sets an alternative string to be used in RTSP "User-Agent:" headers
 
+  // IHP: Adding extra headers for SETUP
+  void setExtraSetupHeaders(char const* extraSetupHeaders);
+
   void disallowBasicAuthentication() { fAllowBasicAuthentication = False; }
       // call this if you don't want the server to request 'Basic' authentication
       // (which would cause the client to send usernames and passwords over the net).
@@ -191,7 +200,7 @@
 
 public: // Some compilers complain if this is "private:"
   // The state of a request-in-progress:
-  class RequestRecord {
+  class LIVEMEDIALIB_API RequestRecord {
   public:
     RequestRecord(unsigned cseq, char const* commandName, responseHandler* handler,
 		  MediaSession* session = NULL, MediaSubsession* subsession = NULL, u_int32_t booleanFlags = 0,
@@ -344,6 +353,10 @@
   char fSessionCookie[33];
   unsigned fSessionCookieCounter;
   Boolean fHTTPTunnelingConnectionIsPending;
+
+  // IHP: Adding extra headers for SETUP
+  char* fExtraSetupHeaderStr;
+  unsigned fExtraSetupHeaderStrLen;
 };
 
 
Index: liveMedia/include/RTSPCommon.hh
===================================================================
--- liveMedia/include/RTSPCommon.hh	(revision 14473)
+++ liveMedia/include/RTSPCommon.hh	(revision 14474)
@@ -45,6 +45,8 @@
 			       unsigned resultURLPreSuffixMaxSize,
 			       char* resultURLSuffix,
 			       unsigned resultURLSuffixMaxSize,
+             char* resultURLParams, // IHP: Added url param parsing
+             unsigned resultURLParamsMaxSize, // IHP: Added url param parsing
 			       char* resultCSeq,
 			       unsigned resultCSeqMaxSize,
 			       char* resultSessionId,
